unit Sli;

interface

type
  TSliFlag = (sfFromStart);
  TSliFlags = set of TSliFlag;

  PSliPlugin = ^TSliPlugin;
  TSliPlugin = record
    Size: Cardinal;

    Name: PWideChar;
    Author: PWideChar;
    Version: PWideChar;

    Flags: TSliFlags;

    Target: PWideChar;
    TargetInfo: Pointer;

    SliMajor: Cardinal;
    SliMinor: Cardinal;
  end;

  TSliException = procedure(Message: PWideChar); cdecl;

  PSliHost = ^TSliHost;
  TSliHost = record
    Size: Cardinal;

    Target: PWideChar;
    TargetInfo: Pointer;

    SliMajor: Cardinal;
    SliMinor: Cardinal;

    RaiseException: TSliException;
  end;

  TSliHeap = class
    procedure Ref; virtual; cdecl; abstract;
    procedure Deref; virtual; cdecl; abstract;
  end;

  TSliProcess = class
    Handle: THandle;
    Thread: THandle;

    ProcessId: Cardinal;
    ThreadId: Cardinal;

    function InjectLibrary(Path: PWideChar; FuncName: PAnsiChar; FuncType: Cardinal; FuncData: Pointer): Cardinal; virtual; cdecl; abstract;
  end;

  TSliVersion = function(const Host: TSliHost): PSliPlugin; cdecl;
  TSliInitialize = procedure(const Host: TSliHost); cdecl;
  TSliFinalize = procedure(const Host: TSliHost); cdecl;

  TSliLoad = procedure(Process: TSliProcess; TargetInfo: Pointer; var Data: Pointer); cdecl;
  TSliUnload = procedure(Process: TSliProcess; TargetInfo: Pointer; Data: Pointer); cdecl;
  TSliClose = procedure(Process: TSliProcess; TargetInfo: Pointer; Data: Pointer); cdecl;

const
  SliMajor = 0;
  SliMinor = 1;

  SliVersion = 'sli_version';
  SliInitialize = 'sli_initialize';
  SliFinalize = 'sli_finalize';

  SliLoad = 'sli_load';
  SliUnload = 'sli_unload';
  SliClose = 'sli_close';

implementation

end.
